# Skynet

We provide a linux webserver webserver for member use.  
It could be considered akin to the [Tildeverse](https://tildeverse.org/), named as such for the way each member's site was displayed (``https://skynet.ie/~username``).  
Now that will redirect to ``https://username.users.skynet.ie`` we home to have preserved the same vibe.  

## Name
The main user facing server of the cluster has always been called Skynet, the cluster is named after this server.  
You can find more of the history here: <https://2009.skynet.ie/history.html>

## Login
Login is done via ssh and ssh keys.

### Create SSH key
First we set up the ssh folder and create a skynet folder within it for neatness
```bash
mkdir -f -p ~/.ssh/skynet
cd ~/.ssh/skynet
```
Now we will create the ssh key itself.  
Location: ``username``, your skynet username.  
Password: Press Enter twice for no password on the key.  
```bash
ssh-keygen -t ed25519 -C "<comment>"
```
It will create two files: ``username`` and ``username.pub``

### SSH Key
Head over to [adding ssh keys](./account.md#ssh-keys) to find information on adding ssh keys to your skynet account.

it is the ``username.pub`` that you will be adding to your account.  
To get the contents of the file do this.
```bash
cat username.pub
```

### SSH Config
Back up to the ``.ssh`` folder.
```bash
cd ../
```

Now we have to create the config file.  
Notice how it has no extension.
#### Windows
```powershell
"" > config
```
Open it up in any text editor available to you.

#### Linux
```bash
touch config
```
You can edit it from command line using nano 

```bash
nano config
```
Or open up in a text editor.


--------------------------------------

Windows and Linux pop this into the file and save it
```
Host *.skynet.ie
   User %r
   IdentityFile ~/.ssh/skynet/%r
   IdentitiesOnly yes
```

### Logging in
In any terminal do this:

```bash
ssh username@skynet.skynet.ie
```
And you will be in!

## Website
In your home folder follow these commands to create the folder that can be used to host a website

```bash
mkdir ~/public_html 
chmod 711 ~
chmod -R 755 ~/public_html
cd ~/public_html 
```

See below for an easy way to upload files to this folder.

## More info
There is a slideshow that might be of use to you: <https://public.skynet.ie/slides/skynet/1_setup.html>